---
import type { InitOptions } from 'decap-cms-core';

import DecapCMS from '~/components/cms/DecapCMS.svelte';
import { env } from '~/lib/env';
import { joinPaths } from '~/lib/path';

export const frontmatter = {
  title: 'Decap CMS',
  order: 2,
  special: 'footer',
  hidden: !env.USE_CMS,
};

const initOptions: InitOptions = {
  config: {
    backend: {
      name: 'git-gateway',
      branch: 'main',
    },
    media_folder: 'public/media',
    public_folder: joinPaths(env.BASE_URL, '/media'),
    local_backend: true,
    collections: [
      {
        name: 'pages',
        label: 'Pages',

        label_singular: 'Page',
        folder: 'src/pages',
        create: true,
        nested: {
          depth: 100,
        },
        fields: [
          {
            label: 'Title',
            name: 'title',
            hint: 'The title of the page',
            widget: 'string',
          },
          {
            label: 'Layout',
            name: 'layout',
            widget: 'select',
            hint: 'The layout to use for this page',
            default: '~/layouts/Prose.astro',
            options: ['~/layouts/Prose.astro', '~/layouts/Default.astro', '~/layouts/Base.astro'],
          },
          {
            label: 'Order',
            name: 'order',
            hint: 'The order of the page. Highest number comes first. Use negative numbers to put pages at the end (lowest number goes last). Leave empty for alphabetical/default order.',
            widget: 'number',
            required: false,
          },
          {
            label: 'Special role',
            name: 'special',
            hint: 'The special role of the page',
            widget: 'select',
            required: false,
            options: ['footer'],
          },
          {
            label: 'Body',
            name: 'body',
            hint: 'The content of the page',
            widget: 'markdown',
          },
        ],
        summary: `{{title}} - {{order | ternary('Order: ', '')}}{{order | default('Unordered')}} - {{special | default('No special role')}}`,
        sortable_fields: ['title', 'order'],
        view_filters: [
          {
            label: 'Special role',
            field: 'special',
            pattern: 'footer',
          },
        ],
        meta: {
          path: {
            widget: 'string',
            index_file: 'index',
            label: 'Path',
            // @ts-ignore - hint is not in the type definition, but it is displayed
            hint: 'The URL path to this page',
          },
        },
      },
      {
        name: 'posts',
        label: 'Posts',
        label_singular: 'Post',
        folder: 'src/content/posts',
        create: true,
        slug: '{{year}}-{{month}}-{{day}}-{{slug}}',
        fields: [
          {
            label: 'Title',
            name: 'title',
            hint: 'The title of the post',
            widget: 'string',
          },
          {
            label: 'Date',
            name: 'date',
            hint: 'The date of the post',
            widget: 'datetime',
          },
          {
            label: 'Image',
            name: 'image',
            hint: 'The header image of this post',
            widget: 'image',
            required: false,
          },
          {
            label: 'Body',
            name: 'body',
            hint: 'The content of the post',
            widget: 'markdown',
          },
        ],
        sortable_fields: ['date', 'title'],
        summary: "{{title}} - {{date | date('YYYY-MM-DD HH:mm:ss')}}",
      },
    ],
  },
};
---

<!doctype html>
<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="robots" content="noindex" />

    <link rel="icon" type="image/svg+xml" href={joinPaths(env.BASE_URL, 'favicon.svg')} />
    <title>{env.SITE_TITLE} - Content Manager</title>
  </head>
  <body>
    <DecapCMS client:only="svelte" initOptions={initOptions} />
  </body>
</html>
